package org.dromara.elevator.service;

import jakarta.servlet.http.HttpServletResponse;
import org.dromara.elevator.domain.bo.DistributionWorkBo;
import org.dromara.elevator.domain.bo.WorkOperationBo;
import org.dromara.elevator.domain.bo.RecordUploadBo;
import org.dromara.elevator.domain.vo.EWorkDataVo;
import org.dromara.elevator.domain.bo.EWorkDataBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;

import java.io.IOException;
import java.util.Collection;
import java.util.List;

/**
 * 工作数据信息;Service接口
 *
 * @author zy
 * @date 2024-07-29
 */
public interface IEWorkDataService {

    /**
     * 查询工作数据信息;
     *
     * @param id 主键
     * @return 工作数据信息;
     */
    EWorkDataVo queryById(Long id);

    /**
     * 分页查询工作数据信息;列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 工作数据信息;分页列表
     */
    TableDataInfo<EWorkDataVo> queryPageList(EWorkDataBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的工作数据信息;列表
     *
     * @param bo 查询条件
     * @return 工作数据信息;列表
     */
    List<EWorkDataVo> queryList(EWorkDataBo bo);

    /**
     * 新增工作数据信息;
     *
     * @param bo 工作数据信息;
     * @return 是否新增成功
     */
    Boolean insertByBo(EWorkDataBo bo);

    /**
     * 修改工作数据信息;
     *
     * @param bo 工作数据信息;
     * @return 是否修改成功
     */
    Boolean updateByBo(EWorkDataBo bo);

    /**
     * 校验并批量删除工作数据信息;信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 工作派发
     * @param bo
     * @return
     */
    boolean distributionWork(DistributionWorkBo bo);

    /**
     * 超期维保数据
     * @param bo
     * @param pageQuery
     * @return
     */
    TableDataInfo<EWorkDataVo> overduePageList(EWorkDataBo bo, PageQuery pageQuery);

    /**
     * 接收
     *
     * @param bo 操作参数
     * @return 是否成功
     */
    boolean receive(WorkOperationBo bo);

    /**
     * 到场
     *
     * @param bo 操作参数
     * @return 是否成功
     */
    boolean arrive(WorkOperationBo bo);

    /**
     * 工作表记录
     *
     * @param bo 操作参数
     * @return 是否成功
     */
    boolean workRecord(WorkOperationBo bo);

    /**
     * 完成
     *
     * @param bo 操作参数
     * @return 是否成功
     */
    boolean complete(WorkOperationBo bo);

    /**
     * 评价
     *
     * @param bo 操作参数
     * @return 是否成功
     */
    boolean evaluate(WorkOperationBo bo);

    /**
     * 修改工作期望时间
     *
     * @param bo 工作信息
     * @return 是否成功
     */
    boolean updateExpectTime(EWorkDataBo bo);

    /**
     * 工作记录上传
     *
     * @param workId             工作数据id
     * @param recordUploadBoList 记录参数
     * @return 是否成功
     */
    boolean uploadRecord(Long workId, List<RecordUploadBo> recordUploadBoList);

    /**
     * 导出维保数据及图片
     * @param param
     * @param resp
     */
    void exportPicture(EWorkDataBo param, HttpServletResponse resp) throws IOException;

    /**
     * 维修单审核
     *
     * @param bo 审核参数
     * @return 是否成功
     */
    boolean auditRepair(EWorkDataBo bo);

    /**
     * 维保结果审核
     * @param bo 审核参数
     * @return 是否成功
     */
    Boolean auditMaintenance(EWorkDataBo bo);
}
